#!/bin/sh
#
# alias-cid.sh - alias CID|TrueType font to CID-Keyed font
#
# Copyright (C) 2000,2001 Taiji Yamada <taiji@aihara.co.jp>
# Copyright (C) 2001 gs-cjk project. All rights reserved.
# This software is provided under the BSD license. For full details,
# please see COPYING file.
#
# Acknowledgment:
# It is a pleasure to thank Hideyuki Suzuki <hideyuki@sat.t.u-tokyo.ac.jp>,
# Jerry Zhang <wenlongzhang@redflag-linux.com>,
# Chih-Wei Huang <cwhuang@linux.org.tw>, Yasuhiro Take <take@debian.org>,
# suzuki toshiya <mpsuzuki@hiroshima-u.ac.jp> and
# Masatake YAMATO <masata-y@is.aist-nara.ac.jp> for many precious suggestions
# and stimulating discussions about this work.
#
#ResourceDir=.
ResourceDir=`echo "pssystemparams /GenericResourceDir get =" | gsnd -q - `
CIDFontDir=$ResourceDir/CIDFont
TTFontDir=/usr/local/share/fonts/truetype
# it requires gs6.51-cjk-*.tar.gz distributed at http://www.gyve.org/gs-cjk/
OpenTTCIDFont=.openttcidfont
cid_sh_path=$ResourceDir
do_cid_sh='no'	# cid.sh is not required since gs6.51-cjk-M2-R1
AliasListFile=./Alias.lst
ttctocid2_ps=ttctocid2.ps

case `basename $0` in
######################################################################
# Adobe CNS1
#
'alias-ac13.sh')
if [ ! -f $AliasListFile ]; then # you can write entries in single quotes
ALIASES='
'
else # otherwise, you can write entries in Alias.lst
ALIASES=` \
  tr -s '	' ' ' < $AliasListFile \
  | sed -n 's/#.*$//g;s/^ *\([^ ]*\) *Adobe[- ]CNS1/\1 /p' \
`
fi
cid_sh=$cid_sh_path/ac13.sh
;;
######################################################################
# Adobe GB1
#
'alias-ag13.sh')
if [ ! -f $AliasListFile ]; then # you can write entries in single quotes
ALIASES='
'
else # otherwise, you can write entries in Alias.lst
ALIASES=` \
  tr -s '	' ' ' < $AliasListFile \
  | sed -n 's/#.*$//g;s/^ *\([^ ]*\) *Adobe[- ]GB1/\1 /p' \
`
fi
cid_sh=$cid_sh_path/ag13.sh
;;
'alias-ag14.sh')
if [ ! -f $AliasListFile ]; then # you can write entries in single quotes
ALIASES='
'
else # otherwise, you can write entries in Alias.lst
ALIASES=` \
  tr -s '	' ' ' < $AliasListFile \
  | sed -n 's/#.*$//g;s/^ *\([^ ]*\) *Adobe[- ]GB1/\1 /p' \
`
fi
cid_sh=$cid_sh_path/ag14.sh
;;
######################################################################
# Adobe Japan1
#
'alias-aj14.sh')
if [ ! -f $AliasListFile ]; then # you can write entries in single quotes
ALIASES='
'
else # otherwise, you can write entries in Alias.lst
ALIASES=` \
  tr -s '	' ' ' < $AliasListFile \
  | sed -n 's/#.*$//g;s/^ *\([^ ]*\) *Adobe[- ]Japan1/\1 /p' \
`
fi
cid_sh=$cid_sh_path/aj14.sh
;;
######################################################################
# Adobe Japan2
#
'alias-aj20.sh')
if [ ! -f $AliasListFile ]; then # you can write entries in single quotes
ALIASES='
'
else # otherwise, you can write entries in Alias.lst
ALIASES=` \
  tr -s '	' ' ' < $AliasListFile \
  | sed -n 's/#.*$//g;s/^ *\([^ ]*\) *Adobe[- ]Japan2/\1 /p' \
`
fi
cid_sh=$cid_sh_path/aj20.sh
;;
######################################################################
# Adobe Korea1
#
'alias-ak12.sh')
if [ ! -f $AliasListFile ]; then # you can write entries in single quotes
ALIASES='
'
else # otherwise, you can write entries in Alias.lst
ALIASES=` \
  tr -s '	' ' ' < $AliasListFile \
  | sed -n 's/#.*$//g;s/^ *\([^ ]*\) *Adobe[- ]Korea1/\1 /p' \
`
fi
cid_sh=$cid_sh_path/ak12.sh
;;
#
# print usage
#
*)
if [ "$1" != 'uninstall' ]; then
  cat <<EOF
do not execute $0, directly! in the case except for uninstall
usage: alias-(ac13|ag14|aj14|aj20|ak12).sh 'install|uninstall' [Alias=Font...]
EOF
  exit 1
fi
;;
esac

case $1 in
'install')
  if [ "$2" != '' ]; then
    shift
    ALIASES=$*
  fi
  for alias in $ALIASES; do
    FNN=`echo $alias|sed -n -e 's/^\(.*\)=\(.*\)$/\1/p'`
    fnn=`echo $alias|sed -n -e 's/^\(.*\)=\(.*\)$/\2/p'`
    [ "$FNN" = '' -o "$fnn" = '' ] && echo "error: $alias" && exit 1
    dot_openttcidfont=$OpenTTCIDFont
    do_ttctocid2='no'
    ttctocid2_ps_flags=''
    case $FNN in
    *:=)
      do_ttctocid2='yes'
      #ttctocid2_ps_flags='-sTTCHANDLER=.opencjkvttcidfont -dVERBCIDMAP'
      ttctocid2_ps_flags='-sTTCHANDLER=.opencjkvttcidfont'
      FNN=`echo $FNN|sed -e 's/:=$//'`
      ;;
    *:)
      do_ttctocid2='yes'
      #ttctocid2_ps_flags='-sTTCHANDLER=.openttcidfont -dVERBCIDMAP'
      ttctocid2_ps_flags='-sTTCHANDLER=.openttcidfont'
      FNN=`echo $FNN|sed -e 's/:$//'`
      ;;
    *=)
      if [ $OpenTTCIDFont = '.openttcidfont' ]; then
        dot_openttcidfont=.opencjkvttcidfont
      else
        dot_openttcidfont=.openttcidfont
      fi
      do_ttctocid2='no'
      FNN=`echo $FNN|sed -e 's/=$//'`
      ;;
    esac
    TTE=''
    case $FNN in
    *-Adobe-*[0-9])
      #TTE=' /'`echo $FNN|sed -n -e 's/^.*-\(Adobe-.*[0-9]\)$/\1/p'`'-Unicode'
      TTE=' /'`echo $FNN|sed -n -e 's/^.*-\(Adobe-.*[0-9]\)$/\1/p'`
      ;;
    #*,Adobe-*[0-9]-*)
    *,Adobe-*[0-9]*)
      #TTE=' /'`echo $FNN|sed -n -e 's/^\(.*\),\(Adobe-.*[0-9]-.*\)$/\2/p'`
      #FNN=`echo $FNN|sed -n -e 's/^\(.*\),\(Adobe-.*[0-9]-.*\)$/\1/p'`
      TTE=' /'`echo $FNN|sed -n -e 's/^\(.*\),\(Adobe-.*[0-9].*\)$/\2/p'`
      FNN=`echo $FNN|sed -n -e 's/^\(.*\),\(Adobe-.*[0-9].*\)$/\1/p'`
      ;;
    esac
    case $fnn in
    *.ttc,[0-9]|*.TTC,[0-9])
      TTF=`echo $fnn|sed -n -e 's/^\(.*\),\([0-9]\)$/\1/p'`
      TTI=`echo $fnn|sed -n -e 's/^\(.*\),\([0-9]\)$/\2/p'`
      if [ ! -f $TTFontDir/$TTF ]; then
        echo "$TTF not found in $TTFontDir"; continue
      fi
      if [ "$do_ttctocid2" = 'no' ]; then
        [ ! -f $CIDFontDir/$FNN ] && cat <<EOF > $CIDFontDir/$FNN && echo "+$FNN=$TTF"
%!PS-Adobe-3.0 Resource-CIDFont
%%BeginResource: CIDFont ($FNN)
/$FNN
($TTFontDir/$TTF) $TTI$TTE $dot_openttcidfont
dup length dict begin {def} forall currentdict end
/CIDFont defineresource pop
%%EndResource
%%EOF
EOF
      else
        if [ "$TTI" != "" ]; then
          TTI="-sINDEX=$TTI"
        fi
        if [ "$TTE" != "" ]; then
          TTE=`echo $TTE|sed -n -e 's/^\/\(.*\)$/-sMAPNAME=\1/p'`
        fi
        [ ! -f $CIDFontDir/$FNN ] && gsnd -q -sINPUT=$TTFontDir/$TTF -sOUTPUTDIR=$CIDFontDir -sRENAME=$FNN -dNONULLINFO $TTI $TTE $ttctocid2_ps_flags $ttctocid2_ps && echo "+$FNN:=$TTF"
      fi
      ;;
    *.tt[fc]|*.TT[FC])
      TTF=$fnn
      if [ ! -f $TTFontDir/$TTF ]; then
        echo "$TTF not found in $TTFontDir"; continue
      fi
      if [ "$do_ttctocid2" = 'no' ]; then
        [ ! -f $CIDFontDir/$FNN ] && cat <<EOF > $CIDFontDir/$FNN && echo "+$FNN=$TTF"
%!PS-Adobe-3.0 Resource-CIDFont
%%BeginResource: CIDFont ($FNN)
/$FNN
($TTFontDir/$TTF)$TTE $dot_openttcidfont
dup length dict begin {def} forall currentdict end
/CIDFont defineresource pop
%%EndResource
%%EOF
EOF
      else
        if [ "$TTE" != "" ]; then
          TTE=`echo $TTE|sed -n -e 's/^\/\(.*\)$/-sMAPNAME=\1/p'`
        fi
        [ ! -f $CIDFontDir/$FNN ] && gsnd -q -sINPUT=$TTFontDir/$TTF -sOUTPUTDIR=$CIDFontDir -sRENAME=$FNN -dNONULLINFO $TTE $ttctocid2_ps_flags $ttctocid2_ps && echo "+$FNN:=$TTF"
      fi
      ;;
    *)
      if [ ! -f $CIDFontDir/$fnn ]; then
        echo "$fnn not found in $CIDFontDir"; continue
      fi
      [ ! -f $CIDFontDir/$FNN ] && cat <<EOF > $CIDFontDir/$FNN && echo "+$FNN=$fnn"
%!PS-Adobe-3.0 Resource-CIDFont
%%BeginResource: CIDFont ($FNN)
/$FNN
/$fnn /CIDFont findresource
dup length dict begin {def} forall currentdict end
/CIDFont defineresource pop
%%EndResource
%%EOF
EOF
      ;;
    esac
    if [ "$do_cid_sh" = 'yes' ]; then
      [ "$cid_sh" != '' ] && (cd $ResourceDir; $cid_sh install $FNN)
    fi
  done
  ;;
'uninstall')
  if [ "$2" != '' ]; then
    shift
    ALIASES=$*
  fi
  for alias in $ALIASES; do
    FNN=`echo $alias|sed -n -e 's/^\(.*\)=\(.*\)$/\1/p'`
    fnn=`echo $alias|sed -n -e 's/^\(.*\)=\(.*\)$/\2/p'`
    case $FNN in
    *:=)
      FNN=`echo $FNN|sed -e 's/:=$//'`
      ;;
    *:)
      FNN=`echo $FNN|sed -e 's/:$//'`
      ;;
    *=)
      FNN=`echo $FNN|sed -e 's/=$//'`
      ;;
    esac
    case $FNN in
    #*,Adobe-*[0-9]-*)
    *,Adobe-*[0-9]*)
      #FNN=`echo $FNN|sed -n -e 's/^\(.*\),\(Adobe-.*[0-9]-.*\)$/\1/p'`
      FNN=`echo $FNN|sed -n -e 's/^\(.*\),\(Adobe-.*[0-9].*\)$/\1/p'`
      ;;
    '')
      FNN=$alias
      ;;
    esac
#    if [ "$do_cid_sh" = 'yes' ]; then
      [ "$cid_sh" != '' ] && (cd $ResourceDir; $cid_sh uninstall $FNN)
      [ "$cid_sh" = '' ] && (cd $ResourceDir; $cid_sh_path/cid.sh uninstall $FNN)
#    fi
    [ -f $CIDFontDir/$FNN ] && rm -f $CIDFontDir/$FNN && echo "-$FNN"
  done
  ;;
*)
  cat <<EOF
usage: $0 'install|uninstall' [Arias=Font...]
please edit the lines ALIASES=<alias>=<name>... of me, before use without args.
EOF
  exit 1
  ;;
esac
exit 0
